Most socially-distanced subsequence CodeForces - 1364B(贪心)

Given a permutation p of length n, find its subsequence s1, s2, …, sk of length at least 2 such that:

|s1−s2|+|s2−s3|+…+|sk−1−sk| is as big as possible over all subsequences of p with length at least 2.
Among all such subsequences, choose the one whose length, k, is as small as possible.
If multiple subsequences satisfy these conditions, you are allowed to find any of them.

A sequence a is a subsequence of an array b if a can be obtained from b by deleting some (possibly, zero or all) elements.

A permutation of length n is an array of length n in which every element from 1 to n occurs exactly once.

Input
The first line contains an integer t (1≤t≤2⋅104) — the number of test cases. The description of the test cases follows.

The first line of each test case contains an integer n (2≤n≤105) — the length of the permutation p.

The second line of each test case contains n integers p1, p2, …, pn (1≤pi≤n, pi are distinct) — the elements of the permutation p.

The sum of n across the test cases doesn’t exceed 105.

Output
For each test case, the first line should contain the length of the found subsequence, k. The second line should contain s1, s2, …, sk — its elements.

If multiple subsequences satisfy these conditions, you are allowed to find any of them.

Example
Input
2
3
3 2 1
4
1 3 4 2
Output
2
3 1
3
1 4 2
Note
In the first test case, there are 4 subsequences of length at least 2:

[3,2] which gives us |3−2|=1.
[3,1] which gives us |3−1|=2.
[2,1] which gives us |2−1|=1.
[3,2,1] which gives us |3−2|+|2−1|=2.
So the answer is either [3,1] or [3,2,1]. Since we want the subsequence to be as short as possible, the answer is [3,1].
思路:根据数组,可以发现,选取峰值就是最优的。
Most socially-distanced subsequence CodeForces - 1364B(贪心)_第1张图片
代码如下:

#include
#define ll long long
using namespace std;

const int maxx=1e5+100;
int a[maxx];
int vis[maxx];
int n;

int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d",&n);
		for(int i=1;i<=n;i++) scanf("%d",&a[i]),vis[i]=0;
		vis[1]=1;
		int cnt=1;
		for(int i=2;i<=n;)
		{
			int j=i;
			if(a[i]>a[i-1]) while(j<=n&&a[j]>a[j-1]) j++;
			else while(j<=n&&a[j]<a[j-1]) j++;
			vis[j-1]=1;
			cnt++;
			i=j;
		}
		cout<<cnt<<endl;
		for(int i=1;i<=n;i++) if(vis[i]) cout<<a[i]<<" ";
		cout<<endl;
	}
	return 0;
}

努力加油a啊,(o)/~

你可能感兴趣的:(Most socially-distanced subsequence CodeForces - 1364B(贪心))